<!DOCTYPE html>
<!-- Generated by pkgdown: do not edit by hand --><html lang="en"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><title>Cache an object to a package's user-cache pins board — cache_obj • pkgpins</title><script src="../lightswitch.js"></script><script src="../deps/jquery-3.6.0/jquery-3.6.0.min.js"></script><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><link href="../deps/bootstrap-5.3.1/bootstrap.min.css" rel="stylesheet"><script src="../deps/bootstrap-5.3.1/bootstrap.bundle.min.js"></script><link href="../deps/font-awesome-6.5.2/css/all.min.css" rel="stylesheet"><link href="../deps/font-awesome-6.5.2/css/v4-shims.min.css" rel="stylesheet"><script src="../deps/headroom-0.11.0/headroom.min.js"></script><script src="../deps/headroom-0.11.0/jQuery.headroom.min.js"></script><script src="../deps/bootstrap-toc-1.0.1/bootstrap-toc.min.js"></script><script src="../deps/clipboard.js-2.0.11/clipboard.min.js"></script><script src="../deps/search-1.0.0/autocomplete.jquery.min.js"></script><script src="../deps/search-1.0.0/fuse.min.js"></script><script src="../deps/search-1.0.0/mark.min.js"></script><!-- pkgdown --><script src="../pkgdown.js"></script><meta property="og:title" content="Cache an object to a package's user-cache pins board — cache_obj"><meta name="description" content="Stores an object in pkg's user-cache pins board, i.e. caches it to the filesystem."><meta property="og:description" content="Stores an object in pkg's user-cache pins board, i.e. caches it to the filesystem."><meta name="twitter:card" content="summary"><meta name="twitter:creator" content="@2BSalim"><meta name="twitter:site" content="@2BSalim"><meta name="robots" content="noindex"><script src="https://rpkg.dev/counter-dev.min.js" data-id="4c4963fe-9fcf-4d81-95bb-2135e114b85b" data-utcoffset="1"></script></head><body>
    <a href="#main" class="visually-hidden-focusable">Skip to contents</a>


    <nav class="navbar navbar-expand-lg fixed-top " aria-label="Site navigation"><div class="container">

    <a class="navbar-brand me-2" href="../index.html">pkgpins</a>

    <small class="nav-text text-danger me-auto" data-bs-toggle="tooltip" data-bs-placement="bottom" title="In-development version">0.8.0.9000</small>


    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div id="navbar" class="collapse navbar-collapse ms-3">
      <ul class="navbar-nav me-auto"><li class="active nav-item"><a class="nav-link" href="../reference/index.html">Reference</a></li>
      </ul><ul class="navbar-nav"><li class="nav-item"><form class="form-inline" role="search">
 <input class="form-control" type="search" name="search-input" id="search-input" autocomplete="off" aria-label="Search site" placeholder="Search for" data-search-index="../search.json"></form></li>
<li class="nav-item"><a class="external-link nav-link" href="https://gitlab.com/rpkg.dev/pkgpins/" aria-label="GitLab"><span class="fa fab fa-gitlab fa-lg"></span></a></li>
<li class="nav-item dropdown">
  <button class="nav-link dropdown-toggle" type="button" id="dropdown-lightswitch" data-bs-toggle="dropdown" aria-expanded="false" aria-haspopup="true" aria-label="Light switch"><span class="fa fa-sun"></span></button>
  <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="dropdown-lightswitch"><li><button class="dropdown-item" data-bs-theme-value="light"><span class="fa fa-sun"></span> Light</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="dark"><span class="fa fa-moon"></span> Dark</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="auto"><span class="fa fa-adjust"></span> Auto</button></li>
  </ul></li>
      </ul></div>


  </div>
</nav><div class="container template-reference-topic">
<div class="row">
  <main id="main" class="col-md-9"><div class="page-header">

      <h1>Cache an object to a package's user-cache pins board</h1>
      <small class="dont-index">Source: <a href="https://gitlab.com/rpkg.dev/pkgpins/blob/HEAD/R/pkgpins.gen.R" class="external-link"><code>R/pkgpins.gen.R</code></a></small>
      <div class="d-none name"><code>cache_obj.Rd</code></div>
    </div>

    <div class="ref-description section level2">
    <p>Stores an object in <code>pkg</code>'s user-cache pins board, i.e. caches it to the filesystem.</p>
    </div>

    <div class="section level2">
    <h2 id="ref-usage">Usage<a class="anchor" aria-label="anchor" href="#ref-usage"></a></h2>
    <div class="sourceCode"><pre class="sourceCode r"><code><span><span class="fu">cache_obj</span><span class="op">(</span><span class="va">board</span>, <span class="va">x</span>, <span class="va">id</span>, qs_preset <span class="op">=</span> <span class="fu"><a href="https://rdrr.io/r/base/c.html" class="external-link">c</a></span><span class="op">(</span><span class="st">"fast"</span>, <span class="st">"balanced"</span>, <span class="st">"high"</span>, <span class="st">"archive"</span><span class="op">)</span><span class="op">)</span></span></code></pre></div>
    </div>

    <div class="section level2">
    <h2 id="arguments">Arguments<a class="anchor" aria-label="anchor" href="#arguments"></a></h2>


<dl><dt id="arg-board">board<a class="anchor" aria-label="anchor" href="#arg-board"></a></dt>
<dd><p><a href="board.html">Package's user-cache pins board</a>.</p></dd>


<dt id="arg-x">x<a class="anchor" aria-label="anchor" href="#arg-x"></a></dt>
<dd><p>Object to be cached.</p></dd>


<dt id="arg-id">id<a class="anchor" aria-label="anchor" href="#arg-id"></a></dt>
<dd><p>Pin name uniquely identifying <code>x</code> in the <code>pkg</code>'s user-cache pins board. A character scalar which is safe to use in paths of common file systems.
Necessary to retrieve <code>x</code> again using <code><a href="get_obj.html">get_obj()</a></code>. An already existing pin named <code>id</code> will be silently overwritten.</p></dd>


<dt id="arg-qs-preset">qs_preset<a class="anchor" aria-label="anchor" href="#arg-qs-preset"></a></dt>
<dd><p>Serialization algorithm preset to use. See <code><a href="https://rdrr.io/pkg/qs/man/qsave.html" class="external-link">qs::qsave()</a></code> (section <em>Presets</em>) for details.</p></dd>

</dl></div>
    <div class="section level2">
    <h2 id="value">Value<a class="anchor" aria-label="anchor" href="#value"></a></h2>
    <p><code>x</code>, invisibly.</p>
    </div>
    <div class="section level2">
    <h2 id="details">Details<a class="anchor" aria-label="anchor" href="#details"></a></h2>
    <p>Note that <code>cache_obj()</code> will always overwrite an already existing cached object of the same <code>id</code>. See <code><a href="hash_fn_call.html">hash_fn_call()</a></code> for a convenient way to create an <code>id</code>
that uniquely identifies a function call. Or just use <code><a href="with_cache.html">with_cache()</a></code> that internally relies on the former.</p>
<p>Note that reading in the cached result from the user-cache pins board (i.e. from the filesystem) might produce a noticeable delay depending on the size of
the cached object. Therefore, it's only recommended to cache results that take a considerable amount of time to recompute. To avoid the overhead of
re-reading a cached result when accessing it multiple times, you can always assign it to an R variable to benefit from direct storage in memory.</p>
    </div>
    <div class="section level2">
    <h2 id="see-also">See also<a class="anchor" aria-label="anchor" href="#see-also"></a></h2>
    <div class="dont-index"><p>Other object handling functions:
<code><a href="get_obj.html">get_obj</a>()</code>,
<code><a href="hash_fn_call.html">hash_fn_call</a>()</code>,
<code><a href="is_cached.html">is_cached</a>()</code>,
<code><a href="rm_obj.html">rm_obj</a>()</code></p></div>
    </div>

    <div class="section level2">
    <h2 id="ref-examples">Examples<a class="anchor" aria-label="anchor" href="#ref-examples"></a></h2>
    <div class="sourceCode"><pre class="sourceCode r"><code><span class="r-in"><span><span class="co"># if the fn below would be part of a real package, we could instead define `this_pkg` globally</span></span></span>
<span class="r-in"><span><span class="co"># using `this_pkg &lt;- utils::packageName()`; instead, we now cache to pkgpins's cache (which</span></span></span>
<span class="r-in"><span><span class="co"># itself never uses the cache)</span></span></span>
<span class="r-in"><span><span class="va">board</span> <span class="op">&lt;-</span> <span class="fu">pkgpins</span><span class="fu">::</span><span class="fu"><a href="board.html">board</a></span><span class="op">(</span>pkg <span class="op">=</span> <span class="st">"pkgpins"</span><span class="op">)</span></span></span>
<span class="r-in"><span></span></span>
<span class="r-in"><span><span class="co"># let's define a fn that returns R pkg sys deps from cache</span></span></span>
<span class="r-in"><span><span class="va">pkg_sys_deps</span> <span class="op">&lt;-</span> <span class="kw">function</span><span class="op">(</span><span class="va">pkg</span>,</span></span>
<span class="r-in"><span>                         <span class="va">os</span> <span class="op">=</span> <span class="st">"ubuntu"</span>,</span></span>
<span class="r-in"><span>                         <span class="va">os_version</span> <span class="op">=</span> <span class="st">"24.04"</span>,</span></span>
<span class="r-in"><span>                         <span class="va">use_cache</span> <span class="op">=</span> <span class="cn">TRUE</span>,</span></span>
<span class="r-in"><span>                         <span class="va">max_cache_age</span> <span class="op">=</span> <span class="st">"6h"</span><span class="op">)</span> <span class="op">{</span></span></span>
<span class="r-in"><span>  <span class="va">fetch</span> <span class="op">&lt;-</span> <span class="cn">TRUE</span></span></span>
<span class="r-in"><span></span></span>
<span class="r-in"><span>  <span class="kw">if</span> <span class="op">(</span><span class="va">use_cache</span><span class="op">)</span> <span class="op">{</span></span></span>
<span class="r-in"><span>    <span class="va">pin_name</span> <span class="op">&lt;-</span> <span class="fu">pkgpins</span><span class="fu">::</span><span class="fu"><a href="hash_fn_call.html">hash_fn_call</a></span><span class="op">(</span>from_fn <span class="op">=</span> <span class="st">"pkg_sys_deps"</span>,</span></span>
<span class="r-in"><span>                                      <span class="va">pkg</span>, <span class="va">os</span>, <span class="va">os_version</span><span class="op">)</span></span></span>
<span class="r-in"><span>    <span class="va">result</span> <span class="op">&lt;-</span> <span class="fu">pkgpins</span><span class="fu">::</span><span class="fu"><a href="get_obj.html">get_obj</a></span><span class="op">(</span>board <span class="op">=</span> <span class="va">board</span>,</span></span>
<span class="r-in"><span>                               id <span class="op">=</span> <span class="va">pin_name</span>,</span></span>
<span class="r-in"><span>                               max_age <span class="op">=</span> <span class="va">max_cache_age</span><span class="op">)</span></span></span>
<span class="r-in"><span>    <span class="va">fetch</span> <span class="op">&lt;-</span> <span class="fu"><a href="https://rdrr.io/r/base/NULL.html" class="external-link">is.null</a></span><span class="op">(</span><span class="va">result</span><span class="op">)</span></span></span>
<span class="r-in"><span>  <span class="op">}</span></span></span>
<span class="r-in"><span>  </span></span>
<span class="r-in"><span>  <span class="kw">if</span> <span class="op">(</span><span class="va">fetch</span><span class="op">)</span> <span class="op">{</span></span></span>
<span class="r-in"><span>    <span class="va">result</span> <span class="op">&lt;-</span></span></span>
<span class="r-in"><span>      <span class="fu">jsonlite</span><span class="fu">::</span><span class="fu"><a href="https://rdrr.io/pkg/jsonlite/man/fromJSON.html" class="external-link">fromJSON</a></span><span class="op">(</span>txt <span class="op">=</span> <span class="fu">glue</span><span class="fu">::</span><span class="fu"><a href="https://glue.tidyverse.org/reference/glue.html" class="external-link">glue</a></span><span class="op">(</span><span class="st">"https://packagemanager.posit.co/__api__/repos/2/sysreqs"</span>,</span></span>
<span class="r-in"><span>                                          <span class="st">"?all=false&amp;pkgname={pkg}&amp;distribution={os}"</span>,</span></span>
<span class="r-in"><span>                                          <span class="st">"&amp;release={os_version}"</span><span class="op">)</span>,</span></span>
<span class="r-in"><span>                         simplifyVector <span class="op">=</span> <span class="cn">FALSE</span><span class="op">)</span> <span class="op">|&gt;</span></span></span>
<span class="r-in"><span>      <span class="fu">purrr</span><span class="fu">::</span><span class="fu"><a href="https://purrr.tidyverse.org/reference/list_flatten.html" class="external-link">list_flatten</a></span><span class="op">(</span><span class="op">)</span></span></span>
<span class="r-in"><span>  <span class="op">}</span></span></span>
<span class="r-in"><span> </span></span>
<span class="r-in"><span>  <span class="kw">if</span> <span class="op">(</span><span class="va">use_cache</span> <span class="op">&amp;&amp;</span> <span class="va">fetch</span><span class="op">)</span> <span class="op">{</span></span></span>
<span class="r-in"><span>    <span class="fu">pkgpins</span><span class="fu">::</span><span class="fu">cache_obj</span><span class="op">(</span>board <span class="op">=</span> <span class="va">board</span>,</span></span>
<span class="r-in"><span>                       x <span class="op">=</span> <span class="va">result</span>,</span></span>
<span class="r-in"><span>                       id <span class="op">=</span> <span class="va">pin_name</span><span class="op">)</span></span></span>
<span class="r-in"><span>  <span class="op">}</span></span></span>
<span class="r-in"><span></span></span>
<span class="r-in"><span>  <span class="va">result</span></span></span>
<span class="r-in"><span><span class="op">}</span></span></span>
<span class="r-in"><span></span></span>
<span class="r-in"><span><span class="co"># now get the sys deps for git2r for the first time (populating the cache)</span></span></span>
<span class="r-in"><span><span class="fu">pkg_sys_deps</span><span class="op">(</span><span class="st">"git2r"</span><span class="op">)</span></span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$name</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> [1] "git2r"</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$requirements</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$requirements$packages</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$requirements$packages[[1]]</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> [1] "libgit2-dev"</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$requirements$install_scripts</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$requirements$install_scripts[[1]]</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> [1] "apt-get install -y libgit2-dev"</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-in"><span></span></span>
<span class="r-in"><span><span class="kw">if</span> <span class="op">(</span><span class="cn">FALSE</span><span class="op">)</span> <span class="op">{</span> <span class="co"># \dontrun{</span></span></span>
<span class="r-in"><span><span class="co"># for the `max_cache_age` (we've set a default of 6h), the cached result will be returned</span></span></span>
<span class="r-in"><span><span class="co"># (as long as `use_cache = TRUE`):</span></span></span>
<span class="r-in"><span><span class="fu">bench</span><span class="fu">::</span><span class="fu"><a href="http://bench.r-lib.org/reference/mark.html" class="external-link">mark</a></span><span class="op">(</span><span class="st">"with cache"</span> <span class="op">=</span> <span class="fu">pkg_sys_deps</span><span class="op">(</span><span class="st">"git2r"</span><span class="op">)</span>,</span></span>
<span class="r-in"><span>            <span class="st">"without cache"</span> <span class="op">=</span> <span class="fu">pkg_sys_deps</span><span class="op">(</span><span class="st">"git2r"</span>, use_cache <span class="op">=</span> <span class="cn">FALSE</span><span class="op">)</span>,</span></span>
<span class="r-in"><span>            iterations <span class="op">=</span> <span class="fl">10</span>,</span></span>
<span class="r-in"><span>            relative <span class="op">=</span> <span class="cn">TRUE</span><span class="op">)</span><span class="op">}</span> <span class="co"># }</span></span></span>
<span class="r-in"><span></span></span>
<span class="r-in"><span><span class="co"># purge cache from the above example</span></span></span>
<span class="r-in"><span><span class="fu">pkgpins</span><span class="fu">::</span><span class="fu"><a href="purge_cache.html">purge_cache</a></span><span class="op">(</span>board <span class="op">=</span> <span class="va">board</span><span class="op">)</span></span></span>
</code></pre></div>
    </div>
  </main><aside class="col-md-3"><nav id="toc" aria-label="Table of contents"><h2>On this page</h2>
    </nav></aside></div>


    <footer><div class="pkgdown-footer-left">
  <p>Developed by Salim Brüggemann.</p>
</div>

<div class="pkgdown-footer-right">
  <p>Site built with <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a> 2.1.1.</p>
</div>

    </footer></div>





  </body></html>

